import ctypes

class Some(ctypes.Structure):
  _fields_ = (
    ('x', ctypes.c_int),
  )
LPSome = ctypes.POINTER(Some)

ThreeProc = ctypes.CFUNCTYPE(None, ctypes.c_int, ctypes.c_int, LPSome)
FourProc = ctypes.CFUNCTYPE(None, ctypes.c_int, ctypes.c_int, ctypes.c_int, LPSome)

ctypes_test = ctypes.cdll.LoadLibrary("./ctypes_test.dll")

def threeprinter(a, b, to):
    print("Three!", a, b, to)
    print(to.contents)
    print(to.contents.x)

def fourprinter(a, b, c, to):
    print("Four!", a, b, c, to)
    print(to.contents)
    print(to.contents.x)

ctypes_test.CallSome(ThreeProc(threeprinter), FourProc(fourprinter))
